<template>
  <el-container class="smart-city-container">
    <!-- 顶部Header -->
    <el-header class="city-header">
      <div class="header-left">
        <img src="@/assets/images/logo.png" alt="" />
        <!-- <span class="city-name">123123</span> -->
      </div>
      <div class="header-right">
        <div class="message-wrap" @click="toMessagePage">
          <el-icon size="20">
            <ChatDotSquare />
          </el-icon>
          <div v-if="messageCount" class="count">{{ messageCount }}</div>
        </div>
        <div>
          <el-dropdown>
            <span class="username">
              {{ userInfo.name }}
            </span>
            <template #dropdown>
              <el-dropdown-menu>
                <el-dropdown-item @click="handleLogout"
                  >退出登录</el-dropdown-item
                >
              </el-dropdown-menu>
            </template>
          </el-dropdown>
        </div>
      </div>
    </el-header>

    <el-container class="container-main">
      <!-- 侧边Aside -->
      <el-aside width="220px" class="city-aside">
        <left-menu></left-menu>
      </el-aside>

      <!-- 主内容Main -->
      <el-main class="city-main">
        <router-view />
      </el-main>
    </el-container>
  </el-container>
</template>

<script setup>
import { computed, ref, onMounted, getCurrentInstance, watch } from "vue";
import { useRouter, useRoute } from "vue-router";
import { useUserStore } from "@/stores/user.js";
import windowConfig from "@/window";
import LeftMenu from "./leftMenu.vue";
import axios from "axios"; // watch中使用proxy会有warning
const userStore = useUserStore();
const proxyRef = ref(null);
const { proxy } = getCurrentInstance();

// 在 setup 中设置
const instance = getCurrentInstance();
if (instance) {
  proxyRef.value = instance.proxy;
}
let userInfo = ref(
  sessionStorage.getItem("userInfo")
    ? JSON.parse(sessionStorage.getItem("userInfo"))
    : [],
);
const router = useRouter();
const route = useRoute();

// 获取资源库数据
const getResourceData = () => {
  axios
    .post(windowConfig.baseUrl + "/api/resource/listResourceAll", {})
    .then((res) => {
      sessionStorage.setItem("resourceData", JSON.stringify(res.data));
    });
};
// 获取未读消息数量
let messageCount = ref(0);
const getMessageCount = () => {
  axios
    .post(windowConfig.baseUrl + "/api/message/getMesCount", {})
    .then((res) => {
      messageCount.value = res.data.count;
    });
};
// 跳转消息列表页
const toMessagePage = () => {
  router.push("/message");
};
onMounted(() => {
  getResourceData();
  getMessageCount();
});

watch(
  () => route.path,
  () => {
    getMessageCount();
  },
);
// 处理退出登录
const handleLogout = () => {
  // 清除登录状态
  proxy.$post({
    url: "/api/user/logout",
    data: {},
    callback: (data) => {
      userStore.clearUserInfo();
      router.replace("/login");
    },
  });
};
</script>

<style scoped lang="less">
.smart-city-container {
  height: 100vh;
  overflow: hidden;
  display: flex;
  flex-direction: column;
  .container-main {
    flex: 1;
    height: 0;
  }
}

/* 选中菜单项样式 */
.el-menu-item {
  color: #666;
  background-color: #fff;
}
.el-menu-item.is-active {
  background-color: #ecf3fd;
  color: #3d84ee;
  border-right: 4px solid #3d84ee;
}

/* 完全去掉系统管理子菜单的背景色 */
:deep(.el-sub-menu__title) {
  color: #666;
  background-color: #fff !important;
}

.city-header {
  width: 100%;
  height: 64px;
  background: #3db8c5 url("@/assets/images/header-bg.png") no-repeat fixed top
    left / 100% 64px;
  color: #fff;
  display: flex;
  align-items: center;
  justify-content: space-between;
  .header-left {
    padding-left: 25px;
  }
}

.city-name {
  font-size: 20px;
  font-weight: bold;
}

.user-info {
  display: flex;
  align-items: center;
  cursor: pointer;
}

.username {
  margin-left: 10px;
  color: #fff;
  cursor: pointer;
}

.city-aside {
  background-color: #fff;
  width: 240px;
  height: 100%;
  box-shadow: 0 6px 10px 0 rgba(36, 36, 63, 0.05);
  overflow: auto;
}

.city-main {
  height: calc(100vh - 60px);
  overflow-y: auto;
  --el-main-padding: 0;
}
.header-right {
  display: flex;
  align-items: center;
  .message-wrap {
    position: relative;
    margin-right: 10px;
    cursor: pointer;
    .count {
      position: absolute;
      top: -5px;
      right: -5px;
      min-width: 14px;
      height: 14px;
      border-radius: 50%;
      background-color: red;
      color: #fff;
      font-size: 10px;
      text-align: center;
      line-height: 14px;
    }
  }
}
</style>
